(**  ` Delphi `׾I    **)
(**  vҬ@ eF ͩҦ      **)
(**   Demo IndyFTPServer Code      **)
(**  YvD,Ю,ۦg  **)

unit XShadow;

interface

uses SysUtils, Windows, ShellAPI, Forms;

const
  DEFAULT_DELIMITERS = [' ', #9, #10, #13];

// From xStrings.pas
function GetToken(const S: string; index: Integer; bTrail: Boolean = False;
  Delimiters: TSysCharSet = DEFAULT_DELIMITERS): string;
function ReplaceString(var S: string; const Token, NewToken: string;
  bCaseSensitive: Boolean): Boolean;

// From xFiles.pas  
function PathWithoutSlash(const Path: string): string;
function PathWithSlash(const Path: string): string;
function ParentDirectory(Path: string): string;
function RelativePath(BaseDir, FilePath: string): string;

implementation

function GetToken(const S: string; index: Integer; bTrail: Boolean = False; Delimiters: TSysCharSet = DEFAULT_DELIMITERS): string;
var
  I, W, head, tail: Integer;
  bInWord         : Boolean;
begin
  I := 1;
  W := 0;
  bInWord := False;
  head := 1;
  tail := Length(S);
  while (I <= Length(S)) and (W <= index) do
  begin
    if S[I] in Delimiters then
    begin
      if (W = index) and bInWord then tail := I - 1;
      bInWord := False;
    end
    else
    begin
      if not bInWord then
      begin
        bInWord := True;
        Inc(W);
        if W = index then head := I;
      end;
    end;

    Inc(I);
  end;

  if bTrail then tail := Length(S);
  
  if W >= index then Result := Copy(S, head, tail - head + 1)
  else Result := '';
end;

function PathWithSlash(const Path: string): string;
begin
  Result := Path;
  if (Length(Result) > 0) and (Result[Length(Result)] <> '\') then AppendStr(Result, '\');
end;

function ReplaceString(var S: string; const Token, NewToken: string;
  bCaseSensitive: Boolean): Boolean;
var
  I: Integer;
  sFirstPart: string;
begin
  if bCaseSensitive then
    I := AnsiPos(Token, S)
  else
    I := AnsiPos(AnsiUpperCase(Token), AnsiUpperCase(S));

  if I <> 0 then
  begin
    sFirstPart := Copy(S, 1, I - 1) + NewToken; // קKLaj
    S := Copy(S, I + Length(Token), Maxint);
  end;

  Result := I <> 0;
  if Result then
  begin
    ReplaceString(S, Token, NewToken, bCaseSensitive);
    S := sFirstPart + S;
  end;
end;

function PathWithoutSlash(const Path: string): string;
begin
  if (Length(Path) > 0) and (Path[Length(Path)] = '\') then
    Result := Copy(Path, 1, Length(Path) - 1)
  else
    Result := Path;
end;

function ParentDirectory(Path: string): string;
var
  iLastAntiSlash: Integer;

  function CountAntiSlash: Integer;
  var
    I: Integer;
  begin
    Result := 0;
    I := 1;
    repeat
      if IsDBCSLeadByte(Ord(Path[I])) then
        Inc(I, 2)
      else
      begin
        if Path[I] = '\' then
        begin
          iLastAntiSlash := I;
          Inc(Result);
        end;
        Inc(I);
      end;
    until I > Length(Path);
  end;

  function UpOneDirectory: string;
  begin
    Result := Copy(Path, 1, iLastAntiSlash); // with slash
  end;

begin
  // 'c:\windows\system\' => 'c:\window\'
  // 'f:\' => 'f:\'
  // '\\xshadow\f\fonts' => '\\xshadow\f\'
  // '\\xshadow\f\' => '\\xshadow\f\'
  Path := PathWithoutSlash(Path);

  if Length(Path) > 3 then
  begin
    if (Path[1] = '\') and (Path[2] = '\') then // UNC path
    begin
      if CountAntiSlash > 3 then
        Result := UpOneDirectory;
    end
    else
    begin
      if CountAntiSlash > 1 then
        Result := UpOneDirectory;
    end;
  end
  else
    Result := Path;
end;

function RelativePath(BaseDir, FilePath: string): string;
begin
  Result := FilePath;
  BaseDir := AnsiUpperCaseFileName(PathWithSlash(BaseDir));
  FilePath := AnsiUpperCaseFileName(FilePath);
  if Copy(FilePath, 1, Length(BaseDir)) = BaseDir then
    Delete(Result, 1, Length(BaseDir));
end;

end.

 